import org.infinispan.Cache;
import org.infinispan.atomic.AtomicMap;
import org.infinispan.atomic.AtomicMapLookup;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.manager.EmbeddedCacheManager;

import javax.transaction.TransactionManager;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Date;
import java.util.Random;

/**
 * Created by IntelliJ IDEA.
 * User: kondrasn
 * Date: 30/08/11
 * Time: 12:27
 * To change this template use File | Settings | File Templates.
 */
public class InfiniCacheBenchmark1 {
    static volatile boolean phase1Over = false;
    static volatile boolean phase2Over = false;
    static String NODE = "A";
    static int ELEMENTS = 2;
    static String CONFIG_FILE_NAME = "./gui-demo-cache-config1-510b.xml";

    public static void main(String[] args) throws Exception {
        ////////////////////////
        // INIT
        ////////////////////////
        try{NODE = args[0];
        }catch (Exception e){}
        try{CONFIG_FILE_NAME = args[1];
        }catch (Exception e){}

        DefaultCacheManager cacheManager = new DefaultCacheManager(CONFIG_FILE_NAME);
        Cache cache = cacheManager.getCache();
        cache.start();
        try{Thread.sleep(10000);}catch (Exception e){}

        try {
            TransactionManager tm = cache.getAdvancedCache().getTransactionManager();
            AtomicMap map = AtomicMapLookup.getAtomicMap(cache, "ATOMIC_MAP", true);
            Random r = new Random();
        ////////////////////////
        // ENTER-KEY HANDLER
        ////////////////////////
            new Thread(new Runnable() {
                public void run() {
                    try{Thread.sleep(10000);}catch (Exception e){}
                    phase1Over = true;
                    try{Thread.sleep(10000);}catch (Exception e){}
                    phase2Over = true;
                }
            }).start();
            log("*******************************************");
            log("************* PHASE 1     MAP   ***********");
            log("*******************************************");
            for (; !phase1Over; ) {
                try {
                    tm.begin();
                    Integer key = r.nextInt(ELEMENTS);
                    map.put(key, r.nextInt(9) + "-" + NODE);
                    Thread.sleep(20);
                    StringBuilder sb = new StringBuilder();
                    for(int i = 0; i < ELEMENTS;i++){
                        sb.append(map.get(i));sb.append(',');
                    }
                    tm.commit();
                    Thread.sleep(200);
                    log(sb.toString());
                } catch (Exception ex) {
                    log(ex.toString());
                }
            }
            log("*******************************************");
            log("************* PHASE 2     CACHE ***********");
            log("*******************************************");
            for (; !phase2Over; ) {
                try {
                    tm.begin();
                    Integer key = r.nextInt(ELEMENTS);
                    cache.put(key, r.nextInt(9) + "-" + NODE);
                    Thread.sleep(20);
                    StringBuilder sb = new StringBuilder();
                    for(int i = 0; i < ELEMENTS;i++){
                        sb.append(cache.get(i));sb.append(',');
                    }
                    tm.commit();
                    Thread.sleep(200);
                    log(sb.toString());
                } catch (Exception ex) {
                    log(ex.toString());
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void log(Object msg) {
        System.out.println(new StringBuilder(new Date().toString()).append(' ').append(msg));
    }
}
